/***********************************************************
 * $Id: fancypcscexception.h 1212 2014-03-15 17:59:36Z fancylibs $
 *
 * FancyLibs PC/SC wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYPCSC_EXCEPTION_H
#define FANCYPCSC_EXCEPTION_H

#include <fancypcsclog.h>
#include <fancyexception.h>

namespace Fancy {
namespace PCSC {

  class FANCYPCSC_API PCSCException : public Fancy::Exception
    {
    public:

	  PCSCException (int facility,
                  int priority,
                  long _err,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
      __attribute__((format(printf,5,6)))
#endif
        ;

      ~PCSCException() throw();

      long getErrno() const throw();
      const char *getStrError() const throw();

    protected:

      PCSCException (fancylog_service *service,
                  int facility,
                  int priority,
                  long _err) throw();

      void appendPCSCMessageV(const char *msg, va_list ap) throw ();
#ifdef __GNUG__
      __attribute__((format(printf,2,3)))
#endif
      void appendPCSCMessage(const char *msg, ...) throw ();

    private:
      long err;
#ifdef WIN32
      char *strerr;
#endif
    };

}} // namespace PCSC, namespace Fancy

#endif // ! FANCYPCSC_EXCEPTION_H
