/***********************************************************
 * $Id: fancypcsclog.h 1168 2014-02-17 14:43:35Z fancylibs $
 *
 * FancyLibs PC/SC wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYPCSC_LOG_H
#define FANCYPCSC_LOG_H

#include <fancypcsc.h>

#include <fancylog.h>

// facility "fancypcsc"
#define  FANCYPCSC_LOG     (1<<0)

namespace Fancy {
namespace PCSC {
  extern FANCYPCSC_API fancylog_service *log_service;

  // parse for logging cmdline args and filter out recognized options.
  void FANCYPCSC_API fancylog_parse_arg (int *argc, char **argv);

  inline void vfancylog (int facility,
                         int priority, const char *fmt, va_list ap)
  {
    va_list aq;
    va_copy(aq,ap);
    ::vfancylog(log_service,facility,priority,fmt,aq);
    va_end(aq);
  }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));

#endif

  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
  {
    va_list ap;
    va_start(ap, fmt);
    vfancylog(facility,priority,fmt,ap);
    va_end(ap);
  }
}
}

#endif // ! FANCYPCSC_LOG_H
